
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define DEBUG 0
#define wca 5.0
#define eqdist 6.6
#define m 6
#define N 1164

#define tag 1164

/*************************************************************************/
/***********************  Function Declarations  *************************/
/*************************************************************************/

#include "./minroutines.c"

/*************************************************************************/
/********************************  MAIN  *********************************/
/*************************************************************************/

main(){

  int i, j, k, test, mode, mode1;
  float movesize, gradsize, de_size, maxsize, temp;
  float crit_move, crit_grad, crit_de, x[1+m], xyz[1+N][1+3];
  float eold, deold[1+m], H[1+m][1+m], K[1+m], S[1+m][1+m];
  float ab[1+m], abold[1+m], ab0[1+m];
  float e, de[1+m];
  FILE *convergence;

  crit_move = 0.001;
  crit_grad = 0.01;
  crit_de = 0.0001;
  maxsize = 0.1;

  getdata(xyz);
  printf("\n  GET INITIAL VALUES FROM FILE");
  convergence = fopen("ghosts.txt", "r");
  for(i=1;i<=m;i=i+1){
    fscanf(convergence, "%f", &temp);
    ab0[i] = temp;
  }
  fclose(convergence);
  fflush(stdout);

  printf("\n  initial ab: ");
  for(j=1;j<=m;j=j+1){
    ab[j] = ab0[j];
    printf(" %.3f ", ab[j]);
    for(k=1;k<=m;k=k+1){
      H[j][k] = 0.0;
    }
    H[j][j] = 1.0 + randomf(0.0, 0.1);
  }
  fflush(stdout);

  convergence = fopen("convergence.txt", "w");
  test = 0;
  for(i=1;test==0;i=i+1){
    if(i != 1){
      eold = e;
      for(j=1;j<=m;j=j+1){
	deold[j] = de[j];
      }
    }
    e = grad(ab, xyz, de);
    printf("\n de = ");
    for(j=1;j<=m;j=j+1){
      printf("%.3f ", de[j]);
    }
    fflush(stdout);
    if(i!=1){
      BFGS_update(x, de, deold, H);
    }
    diagonalize(H, S, K);
    de_size = fabs(e - eold);
    gradsize = sqrt(dot(de, de));
    fprintf(convergence,"\n %d %f %f", i, gradsize, e);
    printf("\n\n  gradients: %d  e: %f  |de|: %f", i, e, gradsize);
    fflush(convergence);
    fflush(stdout);
    for(j=1;j<=m;j=j+1){
      x[j] = 0.0;
      for(k=1;k<=m;k=k+1){
	x[j] = x[j] - (dot(S[k],de)/K[k])*S[k][j];
      }
    }
    movesize = sqrt(dot(x,x));
    printf("\n  RAW MOVESIZE/(B): %f", movesize);
    if(movesize > maxsize){
      for(j=1;j<=m;j=j+1){
	x[j] = x[j]*maxsize/movesize;
      }
    }      
    printf("  NEW MOVESIZE/(B): %f ", sqrt(dot(x,x)));
    for(j=1;j<=m;j=j+1){
      abold[j] = ab[j];
      ab[j] = ab[j] + x[j];
      printf(" %.3f", ab[j]);
    }


    printf("\n  CONVERGENCE TESTING");
    printf("\n   movesize:tolerance  %f::%f", movesize, crit_move);
    printf("\n   gradsize:tolerance  %f::%f", gradsize, crit_grad);
    printf("\n   deltaE:|tolerance|  %f::%f", de_size, crit_de);
    if(movesize < crit_move && gradsize < crit_grad){
      test = 1;
    }
    if(movesize < crit_move && de_size < crit_de){
      test = 1;
    }
    if(de_size < crit_de && gradsize < crit_grad){
      test = 1;
    }
    if(test == 1){
      printf("\n  CONVERGED ");
      for(j=1;j<=m;j=j+1){
	printf("%.4f ", ab[j]);
      }
    }
  }
  fclose(convergence);

  convergence = fopen("answer.txt", "w");
  for(j=1;j<=m;j=j+1){
    fprintf(convergence, "%.4f ", ab[j]);
  }
  fclose(convergence);
  printf("\n");
}


