

/*************************************************************************/
/******************  BOLAS + AIMLESS SHOOTING = EPS  *********************/
/*************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* [Qmin, Qmax] DEFINES THE CURRENT ORDER PARAMETER WINDOW   */
/* Qnext IS OUTSIDE CURRENT OP WINDOW, BUT IN NEXT OP WINDOW */ 
/* 0, 1, 2, ..., frames = OP EVALUATIONS PER EPS TRAJECTORY  */
/* I'VE ONLY USED frames=10, MAY NOT WORK FOR OTHER SETTINGS */
#define Qmin 0.26
#define Qmax 0.78
#define Qnext 0.8
#define frames 10

int randomint(int, int);
void copy_n_state(int);
void copy_o_state(int);
void overwrite(void);

int randomint(int a, int b){
  int diff, aa;
  diff = b - a + 1;
  if(a < 0){
    printf("\n CAREFUL: C's % is not ALGEBRA's MOD");
  }
  aa = rand()%diff;
  return (a+aa);
}

void copy_n_state(int k){
  switch(k){
  case 0:
    system("cp 0.n.crd crd.crd");
    break;
  case 1:
    system("cp 1.n.crd crd.crd");
    break;
  case 2:
    system("cp 2.n.crd crd.crd");
    break;
  case 3:
    system("cp 3.n.crd crd.crd");
    break;
  case 4:
    system("cp 4.n.crd crd.crd");
    break;
  case 5:
    system("cp 5.n.crd crd.crd");
    break;
  case 6:
    system("cp 6.n.crd crd.crd");
    break;
  case 7:
    system("cp 7.n.crd crd.crd");
    break;
  case 8:
    system("cp 8.n.crd crd.crd");
    break;
  case 9:
    system("cp 9.n.crd crd.crd");
    break;
  case 10:
    system("cp 10.n.crd crd.crd");
    break;
  default: 
    printf("\n invalid file index ");
  }
}

void copy_o_state(int k){
  switch(k){
  case 0:
    system("cp 0.o.crd crd.crd");
    break;
  case 1:
    system("cp 1.o.crd crd.crd");
    break;
  case 2:
    system("cp 2.o.crd crd.crd");
    break;
  case 3:
    system("cp 3.o.crd crd.crd");
    break;
  case 4:
    system("cp 4.o.crd crd.crd");
    break;
  case 5:
    system("cp 5.o.crd crd.crd");
    break;
  case 6:
    system("cp 6.o.crd crd.crd");
    break;
  case 7:
    system("cp 7.o.crd crd.crd");
    break;
  case 8:
    system("cp 8.o.crd crd.crd");
    break;
  case 9:
    system("cp 9.o.crd crd.crd");
    break;
  case 10:
    system("cp 10.o.crd crd.crd");
    break;
  default:
    printf("\n invalid file index ");
  }
}

void overwrite(void){
    system("cp 0.n.crd 0.o.crd");
    system("cp 1.n.crd 1.o.crd");
    system("cp 2.n.crd 2.o.crd");
    system("cp 3.n.crd 3.o.crd");
    system("cp 4.n.crd 4.o.crd");
    system("cp 5.n.crd 5.o.crd");
    system("cp 6.n.crd 6.o.crd");
    system("cp 7.n.crd 7.o.crd");
    system("cp 8.n.crd 8.o.crd");
    system("cp 9.n.crd 9.o.crd");
    system("cp 10.n.crd 10.o.crd");
}

/*************************************************************************/
/********************************  MAIN  *********************************/
/*************************************************************************/

main(){

  int i, j, k, acc, sincelastacc;
  float temp, Q[1+10], Q2[1+10];
  FILE *crd, *qfile;
  
  printf("\n  0.o.crd, 1.o.crd, ..., 10.crd SHOULD BE IN WORKING DIRECTORY?");
  // system("ls");  
  /* THE INITIAL X.o.crd FILES CAN ALL BE THE SAME CONFIGURATION */
  printf("\n  MAKING DIR FOR NEXT WINDOW INITIAL TRAJ.");
  system("mkdir NEXTWIN");
  
  printf("\n  BOLAS: SELECT POINT ON PREV TRAJ ASSIGN BOLTZMAN VELOCITIES");
  printf("\n  PROPAGATE BACK,FORW TO 0,T. <DYN, CONCAT, PARSE IN CHARMM>");
  printf("\n  COMPUTE Q ALONG TRAJECTORY. ACCEPT NEW TRAJ IF VISITED WINDOW");
  
  // printf("\n\n  BEGINNING BOLAS");

  qfile = fopen("qfile.txt", "w");

  acc = 0;
  sincelastacc = 0;

  while(acc < 20000){

    sincelastacc = sincelastacc + 1;
    fflush(stdout);
    fflush(qfile);
    k = randomint(0, 10);

    copy_o_state(k);

    k = randomint(0, 10);
    /* SETTING CHARMM VARIABLES LIKE SEED AND SHOOTING POINT */
    crd = fopen("t0.str", "w");
    fprintf(crd, "set seed = %d\n", randomint(0, 10000));
    fprintf(crd, "set k = %d\n", k);
    fclose(crd);
    
    /* MODIFY TO RUN YOUR VERSION OF CHARMM...  */
    system("charmmXXLARGE <fepathsamp.inp> a.txt ");

    i = 0; /* next window */
    j = 0; /* current win */
    for(k=0;k<=10;k=k+1){
      copy_n_state(k);
      /* COPY KTH STATE (CRD FILE) TO A GENERIC CRD FILE CRD.CRD   */
      system("./op.exe");
      /* OP.EXE READS CRD.CRD AND PRINTS ORDER PARAMETERS TO Q.TXT */
      crd = fopen("Q.txt", "r");
      fscanf(crd, "%f ", &temp);
      Q[k] = temp;
      fscanf(crd, "%f ", &temp);
      Q2[k] = temp;
      /* IN THIS CASE, IM KEEPING TRACK OF TWO ORDER PARAMETERS    */

      
      fclose(crd);
      if( Q[k] < Qmax ){
        if( Q[k] > Qmin ){
          j = j + 1;
	  if(j%100 == 1){
	    /* keep configuration */
	    system("cat localW.xyz >> movie.xyz");
	  }
	}
      }
      /* IF j > 0 THE TRAJECTORY VISITED THE OP WINDOW */
      if( Q[k] > Qmax ){
        if( Q[k] < Qnext ){
          i = i + 1;
        }
      }
      if( Q[k] < Qmin ){
        if( Q[k] > Qnext ){
          i = i + 1;
        }
      }
      /* IF i > 0 THE TRAJECTORY VISITED THE NEXT OP WINDOW */
      /* VERY USEFUL FEATURE SAVES A CONFIG IN NEXT WINDOW  */
    }
    if( j > 0 ){
      acc = acc + 1;
      printf("\n %d IN WINDOW %d ACCEPTED", j, acc);
      overwrite();
      fprintf(qfile, "\n%d \n%d", sincelastacc, j); 
      /* for efficiency calculations */
      sincelastacc = 0;
      for(k=0;k<=10;k=k+1){
	if( Q[k] < Qmax ){
	  if( Q[k] > Qmin ){
	    fprintf(qfile, "\n %f %f", Q[k], Q2[k]);
	  }
	}
      }
    }else{
      printf("\n REJECTED");
    }
    if( i > 0 ){
      /* USE THESE AS INITIAL CONFIGURATIONS FOR NEXT WINDOW  */
      system("cp 0.n.crd NEXTWIN/0.o.crd");
      system("cp 1.n.crd NEXTWIN/1.o.crd");
      system("cp 2.n.crd NEXTWIN/2.o.crd");
      system("cp 3.n.crd NEXTWIN/3.o.crd");
      system("cp 4.n.crd NEXTWIN/4.o.crd");
      system("cp 5.n.crd NEXTWIN/5.o.crd");
      system("cp 6.n.crd NEXTWIN/6.o.crd");
      system("cp 7.n.crd NEXTWIN/7.o.crd");
      system("cp 8.n.crd NEXTWIN/8.o.crd");
      system("cp 9.n.crd NEXTWIN/9.o.crd");
      system("cp 10.n.crd NEXTWIN/10.o.crd");
    }      
  }
  fprintf(qfile, "\n 0");
  fclose(qfile);
}




