
void getdata(float [1+N][1+3]);
float dot(float [1+m], float [1+m]);
float normalize(float [1+m]);
void clone(float [1+m], float [1+m]);
void diagonalize(float [1+m][1+m], float [1+m][1+m], float [1+m]);
float randomf(float, float);
void projectfrommatrix(float [1+m], float [1+m][1+m]);
void BFGS_update(float [1+m], float [1+m], 
		 float [1+m], float [1+m][1+m]);
float grad(float [1+m], float [1+N][1+3], float [1+m]); 
float dot3(float [3+1], float [3+1]);
void normalize3(float [1+3]);
void gramschmidt3(float [1+3], float [1+3], float [1+3]);
void cross(float [1+3], float [1+3], float [1+3]);
float sqdist(float [1+3], float [1+3]);
float energy(float [1+N][1+3], float [1+2][1+3]);
float gradient(float [1+N][1+3], float [1+2][1+3], float [1+2][1+3]);
void mx1to2x3(float [1+m], float [1+2][1+3]);
void mx1from2x3(float [1+2][1+3], float [1+m]);


void getdata(float xyz[1+N][1+3]){
  int i, j;
  float temp;
  FILE *xyzfile;
  char indicator[100], c;

  xyzfile = fopen("xyz.xyz","r");
  fscanf(xyzfile,"%d ",&i);
  if(i != N){
    printf(" FILESIZE MISMATCH FOR MINIMIZE.C (xyz.xyz)");
  }
  fgets(indicator, 100, xyzfile);

  for(i=1;i<=N;i=i+1){
    fscanf(xyzfile,"%c ", &c);
    for(j=1;j<=3;j=j+1){
      fscanf(xyzfile,"%f ", &temp);
      xyz[i][j] = temp;
    }
  }
  printf("\n xyz[1][1]=%f",xyz[1][1]);
  printf("\n xyz[1][2]=%f",xyz[1][2]);
  printf("\n xyz[2][2]=%f",xyz[2][2]);

  fflush(stdout);
}

void mx1to2x3(float ab[1+m], float ghost[1+2][1+3]){
  int i, j;
  for(i=1;i<=2;i=i+1){
    for(j=1;j<=3;j=j+1){
      ghost[i][j] = ab[(i-1)*3+j];
    }
  }
}

void mx1from2x3(float ghost[1+2][1+3], float ab[1+m]){
  int i, j;
  for(i=1;i<=2;i=i+1){
    for(j=1;j<=3;j=j+1){
      ab[(i-1)*3+j] = ghost[i][j];
    }
  }
}

float sqdist(float x[1+3], float y[1+3]){
  int k;
  float v[1+3], dp;
  for(k=1;k<=3;k=k+1){
    v[k] = x[k]-y[k];
  }
  dp = dot3(v,v);
  return dp;
}

void cross(float R1[1+3], float R2[1+3], float R3[1+3]){
  R3[1]=R1[2]*R2[3]-R1[3]*R2[2];
  R3[2]=0.0-R1[1]*R2[3]+R1[3]*R2[1];
  R3[3]=R1[1]*R2[2]-R1[2]*R2[1];
}

void gramschmidt3(float v_in[1+3], float u_in[1+3], float v_out[1+3]){
  float temp, temp2;
  int i;
  temp = dot(v_in, u_in);
  temp2 = dot(u_in, u_in);
  for(i=1;i<=3;i=i+1){
    v_out[i] = v_in[i]-temp*u_in[i]/temp2;
  }
}

void normalize3(float x[1+3]){
  float temp;
  int i;
  temp = sqrt(dot3(x,x));
  for(i=1;i<=3;i=i+1){
    x[i] = x[i]/temp;
  }
}

float dot3(float v[3+1], float u[3+1]){
  int k;
  float dp;
  dp = 0.0;
  for(k=1;k<=3;k=k+1){
    dp = dp+v[k]*u[k];
  }
  return dp;
}

float energy(float xyz[1+N][1+3], float ghost[1+2][1+3]){
  int i, j, k;
  float d2[1+2][1+N];
  float e, wca2, temp;
  float kspring;

  kspring = 10.0;
  wca2 = wca*wca;
  e = 0.0;
  for(i=1;i<=N;i=i+1){
    if(i != tag){
      d2[1][i] = sqdist(xyz[i], ghost[1]);
      d2[2][i] = sqdist(xyz[i], ghost[2]);
      if(d2[1][i] < wca2){
	e = e + 5.0/d2[1][i] - 2.0/sqrt(d2[1][i]) + 1.0/5.0;
      }
      if(d2[2][i] < wca2){
	e = e + 5.0/d2[2][i] - 2.0/sqrt(d2[2][i]) + 1.0/5.0;
      }
    }
  }
  d2[0][0] = sqdist(ghost[1], ghost[2]);
  d2[0][0] = sqrt(d2[0][0]);
  temp = eqdist - d2[0][0];
  e = e + kspring*temp*temp/2.0;
  return e;
}

float gradient(float xyz[1+N][1+3],
               float ghost[1+2][1+3], float dV[1+2][1+3]){

  int i, j, k;
  float d2[1+2][1+N], r[1+2][1+N];
  float drdx[1+2][1+N][1+3];
  float e, temp, wca2;
  float kspring;

  kspring = 10.0;
  wca2 = wca*wca;
  e = 0.0;
  for(j=1;j<=3;j=j+1){
    dV[1][j] = 0.0;
    dV[2][j] = 0.0;
  }
  for(i=1;i<=N;i=i+1){
    if(i!=tag){
      d2[1][i] = sqdist(xyz[i], ghost[1]);
      d2[2][i] = sqdist(xyz[i], ghost[2]);
      // printf("\n %.1f %.1f ", sqrt(d2[1][i]), sqrt(d2[2][i]));
      if(d2[1][i] < wca2){
	r[1][i] = sqrt(d2[1][i]);
	temp = 5.0/d2[1][i] - 2.0/r[1][i];
	e = e + temp + 1.0/5.0;
	temp = 2.0 - 10.0/r[1][i];
	temp = temp/d2[1][i];
	for(j=1;j<=3;j=j+1){
	  drdx[1][i][j] = (ghost[1][j]-xyz[i][j])/r[1][i];
	  dV[1][j] = dV[1][j] + temp*drdx[1][i][j];
	}
      }
      if(d2[2][i] < wca2){
	r[2][i] = sqrt(d2[2][i]);
	temp = 5.0/d2[2][i] - 2.0/r[2][i];
	e = e + temp + 1.0/3.0;
	temp = 2.0 - 10.0/r[2][i];
	temp = temp/d2[2][i];
	for(j=1;j<=3;j=j+1){
	  drdx[2][i][j] = (ghost[2][j]-xyz[i][j])/r[2][i];
	  dV[2][j] = dV[2][j] + temp*drdx[2][i][j];
	}
      }
    }
  }
  d2[0][0] = sqdist(ghost[1], ghost[2]);
  d2[0][0] = sqrt(d2[0][0]);
  temp = (d2[0][0]-eqdist)/d2[0][0];
  for(j=1;j<=3;j=j+1){
    dV[1][j] = dV[1][j] + kspring*temp*(ghost[1][j]-ghost[2][j]);
    dV[2][j] = dV[2][j] + kspring*temp*(ghost[2][j]-ghost[1][j]);
  }
  // printf("\n de[1]=%.3f %.3f %.3f", dV[1][1], dV[1][2], dV[1][3]);
  temp = eqdist - d2[0][0];
  e = e + kspring*temp*temp/2.0;
  return e;
}


float grad(float ab[1+m], float xyz[1+N][1+3], float dV[1+m]){

  float ghost[1+2][1+3], g[1+2][1+3], e;

  mx1to2x3(ab, ghost);
  e = gradient(xyz, ghost, g);
  mx1from2x3(g, dV);
  return e;
}





void diagonalize(float hmwc[1+m][1+m],
                 float smwc[1+m][1+m],
                 float w2[1+m]){
  int i, j, k, ndiag, test;
  float diff, tolerance, relerror, evalue;
  float K[1+m][1+m], x[3][1+m];

  ndiag = 1000;

  for(j=1;j<=m;j=j+1){
    for(k=1;k<=m;k=k+1){
      K[j][k] = hmwc[j][k];
    }
  }
  tolerance = .000001;
  if(DEBUG == 1){
    printf("\n  DIAGONALIZING:");
    fflush(stdout);
  }
  for(i=1;i<=m;i=i+1){
    for(j=1;j<=m;j=j+1){
      x[0][j]=randomf(-1.0,1.0);
      x[1][j] = 0.0;
      x[2][j] = 0.0;
    }
    normalize(x[0]);
    test = 0;
    for(k=1;test == 0;k=k+1){
      for(j=1;j<=m;j=j+1){
        x[k%3][j]=dot(K[j],x[(k-1)%3]);
      }
      normalize(x[k%3]);
      relerror = 0.0;
      for(j=1;j<=m;j=j+1){
        diff = x[k%3][j]-x[(k-2)%3][j];
        relerror = relerror + fabs(diff);
      }
      if((relerror < tolerance && k > 100) || (k == ndiag)){
        if(DEBUG == 1){
          printf(".");
          if(k == ndiag){
            printf("\n  itmax reached:");
            printf("    relative error in evect %d: %f",i,relerror);
          }
        }
        for(j=1;j<=m;j=j+1){
          x[(k+1)%3][j] = dot(K[j],x[k%3]);
        }
        w2[i] = dot(x[k%3],x[(k+1)%3]);
        if(DEBUG == 1){
          printf(" (%.2f) ",w2[i]);
        }
        for(j=1;j<=m;j=j+1){
          smwc[i][j] = x[k%3][j];
        }
        projectfrommatrix(smwc[i],K);
        test = 1;
      }
    }
  }
}

float randomf(float a, float b){
  float aa;
  aa = ((float)( rand()%10001))/10000.0;
  return a+(b-a)*aa;
}

void projectfrommatrix(float vector[1+m],
                       float hmwc[1+m][1+m]){
  int i,j,k;
  float p[1+m][1+m];
  float K[1+m][1+m];

  for(i=1;i<=m;i=i+1){
    for(j=1;j<=m;j=j+1){
      if(i == j){
        p[i][j] = 1.0 - vector[i]*vector[j];
      }
      else{
        p[i][j] = - vector[i]*vector[j];
      }
    }
  }
  for(i=1;i<=m;i=i+1){
    for(j=1;j<=m;j=j+1){
      K[i][j] = 0.0;
      for(k=1;k<=m;k=k+1){
        K[i][j] = K[i][j] + hmwc[i][k]*p[k][j];
      }
    }
  }
  for(i=1;i<=m;i=i+1){
    for(j=1;j<=m;j=j+1){
      hmwc[i][j] = 0.0;
      for(k=1;k<=m;k=k+1){
        hmwc[i][j] = hmwc[i][j] + p[i][k]*K[k][j];
      }
    }
  }
}

void BFGS_update(float dx[1+m],
                 float g_new[1+m], float g_old[1+m],
                 float h[1+m][1+m]){

  int i, j, k;
  float Hdx[1+m], y[1+m], dxy;
  float r[1+m], theta, dxHdx, dxr;

  printf("\n  DAMPED BFGS HESSIAN UPDATE p.541 NOCEDAL & WRIGHT");
  printf("\n    SECANT");
  for(j=1;j<=m;j=j+1){
    y[j] = g_new[j] - g_old[j];
  }
  printf("  H.dx:");
  for(i=1;i<=m;i=i+1){
    Hdx[i] = dot(h[i], dx);
    printf(" %.2f",Hdx[i]);
  }
  dxHdx = dot(dx, Hdx);
  dxy = dot(dx, y);
  if( dxy > 0.2*dxHdx ){
    theta = 1.0;
  }else{
    theta = 0.8*dxHdx/(dxHdx-dxy);
  }
  printf("  theta: %.3f", theta);
  for(i=1;i<=m;i=i+1){
    r[i] = theta*y[i]+(1.0-theta)*Hdx[i];
  }
  dxr = dot(r, dx);
  for(i=1;i<=m;i=i+1){
    for(j=1;j<=m;j=j+1){
      h[i][j] = h[i][j] - Hdx[i]*Hdx[j]/dxHdx + r[i]*r[j]/dxr;
    }
  }
}

void clone(float x[1+m], float y[1+m]){
  int i;
  for(i=1;i<=m;i=i+1){
    y[i] = x[i];
  }
}

float normalize(float x[1+m]){
  float numer;
  int j;
  numer = 0.0;
  for(j=1;j<=m;j=j+1){
    numer = numer + x[j]*x[j];
  }
  numer = sqrt(numer);
  for(j=1;j<=m;j=j+1){
    x[j] = x[j]/numer;
  }
  return numer;
}

float dot(float v[m+1], float u[m+1]){
  int k;
  float dp;
  dp = 0.0;
  for(k=1;k<=m;k=k+1){
    dp = dp+v[k]*u[k];
  }
  return dp;
}


