

/******************************************************************/
/*************************  BOLAS  ********************************/
/******************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "./qminqmax2D.txt"


int bin(int, float [1+MXGAPS], float);

int bin(int GAPS, float q[1+MXGAPS], float Q){
  int i, k;
  k = 1;
  for(i=1;i<=GAPS;i=i+1){
    if( Q > q[i] ){
      k = i;
    }
  }
  return k;
}

/*************************************************************************/
/********************************  MAIN  *********************************/
/*************************************************************************/

main(){

  int i, j, k, k1max, k2max, bin1[1+11], bin2[1+11], p[1+MXGAPS][1+MXGAPS];
  float pairQs[1+2], Q, Q2, dq2, temp, fmin, fmax, f;
  float q2[1+MXGAPS], q1[1+MXGAPS], dq1[1+MXGAPS];
  FILE *in, *out, *crd;

  for(i=1;i<=MXGAPS;i=i+1){
    for(j=1;j<=MXGAPS;j=j+1){
      p[i][j] = 0;
    }
  }

  system("cat qfile.txt endfile.txt > qfile2.txt");
  system("wc bins.txt > i");
  in = fopen("i", "r");
  fscanf(in, "%d ", &k1max);
  fclose(in);  
  /* include a final end of line char in bins.txt */

  k=0;
  pairQs[1] = -10000.0;
  pairQs[2] = -10000.0;
  in = fopen("bins.txt", "r");
  for(i=1;i<=k1max;i=i+1){
    fscanf(in, "%f ", &temp);
    pairQs[1] = pairQs[2];
    pairQs[2] = temp;
    temp = (pairQs[1]+pairQs[2])/2.0;
    if(temp < Qmax){
      if(temp > Qmin){
	k = k+1;
	q1[k] = pairQs[1];
	q1[k+1] = pairQs[2];
	dq1[k] = q1[k+1]-q1[k];
      }
    }
  }
  fclose(in);

  k1max = k;
  bin1[0] = k1max;
  
  k2max = (int)((Q2max-Q2min)/dQ2);
  printf(" \n k2max = %d", k2max);

  k=0;
  for(i=1;i<=k2max;i=i+1){
    q2[i] = Q2min + ((float)(i-1))*dQ2;
  }
  bin2[0] = k2max;

  printf("\n");
  for(i=1;i<=bin1[0];i=i+1){
    printf("\n %d: [%.2f, %.2f] dq=%.2f", i, q1[i], q1[i+1], dq1[i]);
  }
  printf("\n\n dq2=%.2f", dQ2);
  for(i=1;i<=bin2[0];i=i+1){
    printf("\n %d: [%.2f, %.2f]", i, q2[i], q2[i]+dQ2);
  }
  
  in = fopen("qfile2.txt", "r");
  fscanf(in, "%d ", &i); // a useless int
  // printf("\n %d", i);
  fscanf(in, "%d ", &i); // hits on 1st trajectory
  printf("\n %d", i);
  while(i > 0){ 
    for(j=1;j<=i;j=j+1){
      fscanf(in, "%f %f", &Q, &Q2);
      bin1[j] = bin(bin1[0], q1, Q);
      bin2[j] = bin(bin2[0], q2, Q2);
      printf(" (%d,%d)", bin1[j], bin2[j]);
    }
    fscanf(in, "%d ", &k); // weight of trajectory (rejectns)
    printf("   %d", k);
    for(j=1;j<=i;j=j+1){
      p[bin1[j]][bin2[j]] = p[bin1[j]][bin2[j]] + k;
    }
    fscanf(in, "%d ", &i);
    printf("\n %d", i);
  } 
  fclose(in);

  fmin =  100000.0;
  fmax = -100000.0;
  in = fopen("mma1.txt","w");
  out = fopen("mma2.txt","w");
  crd = fopen("whamdata.txt","w");
  fprintf(out,"\ndq={");
  fprintf(in, "winF={\n");
  printf("\n\n    ");   
  for(j=1;j<=k2max;j=j+1){
    printf(" %.1f", q2[j]+dQ2/2.0);
  }
  fprintf(crd, "\n\n %d %d", k1max, k2max);
  for(i=1;i<=k1max;i=i+1){
    printf("\n%.2f ", (q1[i]+q1[i+1])/2.0);
    for(j=1;j<=k2max;j=j+1){

      fprintf(crd, "\n %.3f %.3f %.3f %.3f %d", 
	      q1[i+1]-q1[i], dQ2, 
	      (q1[i]+q1[i+1])/2.0,
	      q2[j]+dQ2/2.0, p[i][j]);

      if(p[i][j] > 0){
	f = -log(((float)p[i][j])/(dq1[i]*dQ2));
	fprintf(in, ",{%.4f, %.4f, %.4f}",
		(q1[i]+q1[i+1])/2.0, q2[j]+dQ2/2.0, f);
	printf(" %.1f", f);
	if(f < fmin){
	  fmin = f;
	}
	if(f > fmax){
	  fmax = f;
	}
	fprintf(out,",{%.3f,%.3f}", dq1[i], dQ2);
      }
      else{
	printf("   ");
      }
    }
  }
  fprintf(out,"};\n");
  fprintf(in,"};\n fmin=%.4f;\n fmax=%.4f;\n", fmin, fmax);

  fclose(out);
  fclose(in);
  fclose(crd);


  system("cat mma1.txt mma2.txt > mma.txt");
  system("rm mma1.txt mma2.txt");

}




